#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "fsig.h"

static int read_bytes(FILE *f, char *buf, int siz)
{
  return fread(buf, 1, siz, f);
}

uint64_t find_sig(FILE *f, char *sig, int siglen)
{
  uint64_t pos;
  char buf[2048];
  int buflen, bufhead;
  uint64_t bufpos;

  int req,R,i;

  pos= ftell(f);
  
  bufpos= pos;
  buflen= 0;
  bufhead= 0;

  while(1)
  {
    while (buflen<siglen)
    {
      if (buflen==0)
      {
        bufhead= 0;
        buflen= read_bytes(f, buf, 2048);
        if (buflen<siglen) goto fail;
      } 
      else 
      {
        if (bufhead+buflen<2048)
           req= 2048 - (bufhead+buflen);
        else
           req= bufhead - (bufhead+buflen)%2048;

        R= read_bytes(f, buf+(bufhead+buflen)%2048, req);
        if (R<=0) goto fail;
        buflen+= R;
      }
    }

    while(buflen>=siglen)
    {
       for(i=0;i<siglen;i++)
         if (buf[(i+bufhead)%2048]!=sig[i]) break;
       if (i==siglen) goto success;
       
       bufpos++;
       bufhead= (bufhead+1)%2048;
       buflen--;
    }
  }

success:
   fseek(f, bufpos, SEEK_SET);
   return bufpos;

fail:
   fseek(f, pos, SEEK_SET);
   return 0;
}
